package com.V10lator.SignClock;

import java.io.FileWriter;
import java.io.IOException;
import java.util.Collection;

public class SaveThread extends Thread
{
  private final SignClock plugin;
  public SaveThread(final SignClock plugin)
  {
    this.plugin = plugin;
  }
  
  public void run()
  {
    int ret = save();
    if(ret < 0)
    {
      if(ret == -1)
        this.plugin.info2log("Can't save (" + ret + ")");
    }
	else
	  this.plugin.info2log(ret + " Events saved");
  }
  
  public short save()
  {
	//Write file to ram
	Collection<SClock> signs = plugin.getValues();
	short c = 0;
	int p = 0;
	if(this.plugin.permissionsActive())
	  p = 1;
	String out = "V1.1," + p + "\n";
	for(SClock sign: signs)
	{
	  short trigger = 0;
	  if(sign.isTriggered())
		trigger = 1;
	  out = out + 
		    sign.getWorld() + "," + 
		    sign.getX() + "," + 
		    sign.getY() + "," + 
		    sign.getZ() + "," + 
		    sign.getStyle() + "," + 
		    trigger + "\n";
	  c++;
	}
	if(plugin.Init.saveRAM.equals(out))
	  return -2;
	
	try
	{
	  FileWriter writer = new FileWriter(this.plugin.Init.saveFile);
	  writer.write(out);
	  plugin.Init.saveRAM = out;
	  writer.close();
	}
	catch (IOException e)
	{
	  return -1;
	}
	return c;
  }
}

