package com.V10lator.SignClock;

import java.util.Collection;
import java.util.HashMap;
import java.util.logging.Logger;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.Server;

import com.V10lator.SignClock.themeLib;
import com.V10lator.SignClock.triggerRAM;
import com.V10lator.lib24time.lib24time;

public class SignClock extends JavaPlugin
{
  private Logger log = Logger.getLogger("Minecraft");
  public String name;
  private final SignClockBlockListener blockListener = new SignClockBlockListener(this);
  private final SignClockPlayerListener playerListener = new SignClockPlayerListener(this);
  private final HashMap<Block, SClock> signs = new HashMap<Block, SClock>();
  public final themeLib themeLib = new themeLib(this);
  public final triggerRAM triggerRAM = new triggerRAM();
  public Init Init;
  public int mt;
  private final HashMap<String, String> marquees = new HashMap<String, String>();
  private boolean permissions = false;

  public void onEnable()
  {
	int saveIntervall = 15;
	Server server = getServer();
    PluginManager pm = server.getPluginManager();
    if(!lib24time.isInitialized())
	{
	  info2log("ERROR: lib24time not ready!");
	  pm.disablePlugin(this);
	  return;
	}
	if(lib24time.getVersion() < 0.7)
	{
	  info2log("ERROR: lib24time >= 0.7 needed (" + lib24time.getVersion() + " found)");
	  pm.disablePlugin(this);
	  return;
	}
    
    pm.registerEvent(Event.Type.SIGN_CHANGE, blockListener, Event.Priority.Normal, this);
    pm.registerEvent(Event.Type.REDSTONE_CHANGE, blockListener, Event.Priority.Normal, this);
    pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener, Event.Priority.Normal, this);
    pm.registerEvent(Event.Type.PLAYER_INTERACT, playerListener, Event.Priority.Normal, this);
    getCommand("SignClock").setExecutor(new CommandParser(this));
    
    PluginDescriptionFile pdfFile = this.getDescription();
    this.name = pdfFile.getName();

    Init = new Init(this);
    
    if(this.Init.initialize((short)0) < 0)
    {
      pm.disablePlugin(this);
      return;
    }
    
    if(!themeLib.initialize())
    {
      pm.disablePlugin(this);
      return;
    }
    
    this.getServer().getScheduler().scheduleSyncRepeatingTask(this, new frameTick(this), 1, 16);
    this.getServer().getScheduler().scheduleSyncRepeatingTask(this, new triggerTicker(this), 1, 8);
    
    int init = this.Init.initialize((short)1);
    if(init == -1)
    {
      pm.disablePlugin(this);
      return;
    }
    else if(init == -2)
    {
      pm.disablePlugin(this);
      pm.enablePlugin(this);
      return;
    }
    else
      this.info2log(init + " SignClocks resetted");
    
    getServer().getScheduler().scheduleSyncRepeatingTask(this, new SaveThread(this), 60 * saveIntervall * 10, 60 * saveIntervall * 10);
    this.info2log("v" + pdfFile.getVersion() + " enabled");
  }
  
  public void onDisable()
  {
	this.getServer().getScheduler().cancelTasks(this);
	SaveThread st = new SaveThread(this);
	st.run();
    this.info2log("disabled");
  }

  public void info2log(String text)
  {
    log.info("[" + this.name + "] " + text + ".");
  }
  
  public void addSign(Block block, SClock sign)
  {
    if(sign.isTriggered())
      triggerRAM.addSign(block.getWorld().getName(), block.getX(), block.getY(), block.getZ());

    //add Sign to hashmap
    signs.put(block, sign);
  }
	    
  public boolean isSignClock(Block block)
  {
    return signs.containsKey(block);
  }
	    
  public void removeSign(Block block)
  {
	triggerRAM.removeSign(block.getWorld().getName(), block.getX(), block.getY(), block.getZ());
    signs.remove(block);
  }
	    
  public SClock getSignClock(Block block)
  {
    if(!isSignClock(block))
      return null;
	return signs.get(block);
  }
  
  public boolean hasPermission(Player player, String perm)
  {
	if(!player.isOnline())
	  return false;
	if(!this.permissions)
	  return true;
	return player.hasPermission("SignClock." + perm);
  }
  
  public boolean permissionsActive()
  {
	return this.permissions;
  }
  public void setPermissions(boolean magic)
  {
	this.permissions = magic;
  }
  
  public Collection<SClock> getValues()
  {
	return this.signs.values();
  }
  
  public String getMarquee(String dt)
  {
	return this.marquees.get(dt);
  }
  
  public void setMarquee(String dt, String st)
  {
	this.marquees.put(dt, st);
  }
  
  public void replaceMarquee(String dt, String st)
  {
	this.marquees.remove(dt);
	this.marquees.put(dt, st);
  }
}