package com.V10lator.SignClock;

import java.util.ArrayList;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FilenameFilter;
import java.io.StringWriter;
import java.io.IOException;

import org.bukkit.ChatColor;

public class themeLib {
  private final SignClock plugin;
  public ArrayList<String> themes = new ArrayList<String>();
  public ArrayList<String> ThemeNames = new ArrayList<String>();
  public ArrayList<ArrayList<String>> frame = new ArrayList<ArrayList<String>>();
  public ArrayList<Integer> frames = new ArrayList<Integer>();
  public ArrayList<String> currentFrame = new ArrayList<String>();
  public ArrayList<Integer> lastFrame = new ArrayList<Integer>();
  
  public themeLib(final SignClock plugin)
  {
    this.plugin = plugin;
  }
	
  public boolean initialize()
  {
    File themesDir = new File("plugins/V10lator/themes");
    FilenameFilter select = new FileListFilter("", "sgt");
    File[] themeArray = themesDir.listFiles(select);
    
    if (themeArray == null)
      return false;
    int c = 0;
    for(File themeFile: themeArray)
    {
      String themeName = themeFile.getName();
      try
      {
        BufferedReader reader = new BufferedReader(new FileReader(themeFile));
        char[] buffer = new char[1024];
        String out = "";
        int n;
        StringWriter tmpwriter = new StringWriter();
		while ((n = reader.read(buffer)) != -1)
		{
		  tmpwriter.write(buffer, 0, n);
		}
		out = tmpwriter.toString();
		
		//Colors:
		out = out.replace("[AQUA]", ""+ChatColor.AQUA);
		out = out.replace("[BLACK]", ""+ChatColor.BLACK);
		out = out.replace("[BLUE]", ""+ChatColor.BLUE);
		out = out.replace("[DARK_AQUA]", ""+ChatColor.DARK_AQUA);
		out = out.replace("[DARK_BLUE]", ""+ChatColor.DARK_BLUE);
		out = out.replace("[DARK_GREEN]", ""+ChatColor.DARK_GREEN);
		out = out.replace("[DARK_PURPLE]", ""+ChatColor.DARK_PURPLE);
		out = out.replace("[DARK_RED]", ""+ChatColor.DARK_RED);
		out = out.replace("[GOLD]", ""+ChatColor.GOLD);
		out = out.replace("[GRAY]", ""+ChatColor.GRAY);
		out = out.replace("[GREEN]", ""+ChatColor.GREEN);
		out = out.replace("[LIGHT_PURPLE]", ""+ChatColor.LIGHT_PURPLE);
		out = out.replace("[RED]", ""+ChatColor.RED);
		out = out.replace("[WHITE]", ""+ChatColor.WHITE);
		out = out.replace("[YELLOW]", ""+ChatColor.YELLOW);

        int trenner = themeName.lastIndexOf('.');
        this.ThemeNames.add(c, themeFile.getName().substring(0, trenner));
        this.themes.add(c,out);
        String[] tmpsplit = out.split("\n");
        this.frames.add(c, tmpsplit.length / 4);
        this.lastFrame.add(c,0);
        int count[] = {0,0,0};
        ArrayList<String> frameList = new ArrayList<String>();
        while(count[0] < tmpsplit.length)
        {
          int tlen = tmpsplit.length - count[0];
          count[2] = 0;
          String frame = "";
          while((count[2] < tlen) && (count[2] < 4))
          {
            frame = frame + tmpsplit[count[0] + count[2]] + "\n";
            count[2]++;
          }
          count[0] = count[0] + 4;
          frameList.add(count[1], frame);
          count[1]++;
        }
        this.currentFrame.add(c,"\nPlease attach\nRedstone!");
        this.frame.add(c,frameList);
      }
      catch(IOException e)
      {
    	return false;
      }
      c++;
    }
    plugin.info2log(c + " Themes loaded");
    return true;
    
  }
  
  public String getFrame(String theme)
  {
    int found = -1;
    int c = 0;
    while(c < this.ThemeNames.size())
    {
      if(theme.equals(this.ThemeNames.get(c)))
	  {
	    found = c;
	    break;
      }
	  c++;
    }
	if(found < 0)
	  return(ChatColor.RED + "ThemeNotFound!\n" + ChatColor.RED + theme + "\n\n" + ChatColor.GRAY + "[TIM]");
	else
	  return this.currentFrame.get(found);
  }
  public boolean isTheme(String theme)
  {
    boolean found = false;
	int c = 0;
	while(c < this.ThemeNames.size())
	{
	  if(theme.equals(this.ThemeNames.get(c)))
	  {
	    found = true;
		break;
	  }
	  c++;
	}
	return found;
  }
  public int getThemeID(String theme)
  {
	int found = -1;
	int c = 0;
	while(c < this.ThemeNames.size())
	{
	  if(theme.equals(this.ThemeNames.get(c)))
	  {
	    found = c;
		break;
	  }
	  c++;
	}
	return found;	
  }
}

  class FileListFilter implements FilenameFilter {
	  private String name; 

	  private String extension; 

	  public FileListFilter(String name, String extension) {
	    this.name = name;
	    this.extension = extension;
	  }

	  public boolean accept(File directory, String filename) {
	    boolean fileOK = true;

	    if (name != null) {
	      fileOK &= filename.startsWith(name);
	    }

	    if (extension != null) {
	      fileOK &= filename.endsWith('.' + extension);
	    }
	    return fileOK;
	  }
	}